// ejercicio de realimentación SISO no controlable

clear
xdel(winsid())
clc

// datos del problema

A1=12;
A2=45;
A3=15;
R1=120;
R2=360;
R3=72;
R4=300;
A0=1;
K1=0;
K2=0;
K3=0;
Ts=10;

// matrices del modelo continuo

A=[-((R1+R2)/(A1*R1*R2)) 0 0; 1/(A2*R1) -1/(R3*A2) 1/(R3*A2); 0 1/(R3*A3) -((R3+R4)/(A3*R3*R4))];
B=[1/A1 0; 0 0; 0 1/A3];
C=[0 1 0; 1/R1 0 0];
D=[0 0;0 0];

P1=syslin("c",A,B,C,D)

U1=cont_mat(A,B(:,2))
rank(U1)
// Para el control del caudal se utilizará un actuador 
// cuya ganancia es Kq=0.007 m3/volt 
Kq=0.007;
B2=Kq*B(:,2)
C2=eye(3,3)
D2=zeros(3,1)
X0=[0;0;0]
X0=[2;0;0]
P2=syslin("c",A,B2,C2,D2,X0)
G2=ss2tf(P2)

// SIMULACIÓN

tiempo=[0:Ts:100000]; // Vector de Tiempos
u=ones(1,length(tiempo));
Y=csim(u,tiempo,P2); // Simulación

// GRÁFICO VARIABLES DE ESTADO A LAZO ABIERTO 

subplot(3,1,1)
plot2d(tiempo,Y(1,:),color("red"));
xgrid(color("gray"))
title('Respuesta de las variables de estado')
ylabel("Tanque nº 1");
subplot(3,1,2)
plot2d(tiempo,Y(2,:),color("blue"));
xgrid(color("gray"))
ylabel("Tanque nº 2");
subplot(3,1,3)
plot2d(tiempo,Y(3,:),color("scilabgreen4"));
xgrid(color("gray"))
ylabel("Tanque nº 3");

// discretización del modelo continuo
Ts=10;

P3=dscr(P2,Ts)
G3=ss2tf(P3);
zpk(P3)

Ad=P3.a;
Bd=P3.b;
Cd=[0,1,0];
Dd=[0];

autov=spec(Ad)

U3=cont_mat(Ad,Bd)
rank(U3)
q1=[1; 0; 0];
Q=[U3(:,1) U3(:,2) q1]
P4=ss2ss(P3,Q)

// sub-sistema controlable

P5=syslin("d",P4.a(1:2,1:2),P4.b(1:2,1),P4.c(1,1:2),P4.d(1,1))

// elección de los autovalores
// tiempo de establecimiento 3000 seg
// sobrepico 5%
// AUTOVALORES.
// PARA EL TIEMPO DE ESTABLECIMIENTO Test=4/(Psi Wn)
// PARA EL SOBREPICO SP= EXP(-Psi Pi/(1-Psi^2)^0.5)
SP=0.05;
Test=3000;
Psi= sqrt((log(SP))^2/((log(SP))^2+%pi^2))
Wn = 4/(Psi*Test)
p1 = -Psi*Wn+%i*Wn*sqrt(1-Psi^2)
p2 = -Psi*Wn-%i*Wn*sqrt(1-Psi^2)

// autovalores discretos

polos=[exp(p1*Ts) exp(p2*Ts)]

// realimentación controlable
A0=1
Kt1=ppol(P5.a,P5.b,polos)

Ktc=[Kt1 0]

Kt=Ktc*Q^-1

// ajuste de ganancia

K0=Cd*(eye(3,3)-(Ad-Bd*Kt))^-1*Bd

A0=1/K0

Kt0=Kt/A0

Alc = [(Ad-Bd*Kt)]
Blc = [Bd*A0]
Clc=[[0,1,0];-Kt]
Dlc=[0;A0]
X0=[0;0;0]
P4_dis=syslin("d",Alc,Blc,Clc,Dlc,X0); // Modelo de Lazo Cerrado

tiempo=[0:Ts:10000]; // Vector de Tiempos
u=ones(1,length(tiempo));
Y=dsimul(P4_dis,u); // Simulación
// GRÁFICO VARIABLES DE ESTADO A LAZO ABIERTO 
xdel(winsid());
subplot(2,1,1)
plot2d(tiempo,Y(1,:),color("red"));
xgrid(color("gray"))
title('Respuesta de las variables de estado')
ylabel("Posición");
subplot(2,1,2)
plot2d(tiempo,Y(2,:),color("blue"));
xgrid(color("gray"))
ylabel("Control");
// LUGAR DE RAICES
xdel(winsid())
Clc=Kt;
P5_dis=syslin("d",Ad,Bd,Clc,Dd);
GH=ss2tf(P5_dis);
zpk(GH)
evans(GH,10)
xgrid(color("gray"))
